#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2300four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 2300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2300four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four23004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four23004xi = {
                1:'1025x-1506y1402z',
                2:'1031x-2024y360z',
                3:'1048x-645y1942z',
                4:'1057x-1122y1706z',
                5:'1097x-599y1930z',
                6:'1111x-1461y1384z',
                7:'1127x-1077y1690z',
                8:'1137x-1970y337z',
                9:'1144x-549y1917z',
                10:'117x-2232y540z',
                11:'1189x-495y1904z',
                12:'1194x-1027y1675z',
                13:'1195x-1412y1366z',
                14:'1231x-439y1891z',
                15:'1240x-1910y314z',
                16:'1260x-974y1659z',
                17:'1271x-379y1878z',
                18:'1277x-1357y1347z',
                19:'1307x-317y1865z',
                20:'1322x-916y1643z',
                21:'1340x-1845y291z',
                22:'1340x-251y1851z',
                23:'1356x-1298y1328z',
                24:'136x-104y2293z',
                25:'1370x-183y1838z',
                26:'1382x-854y1627z',
                27:'1396x-113y1824z',
                28:'1418x-40y1810z',
                29:'1432x-1234y1309z',
                30:'1437x-1775y268z',
                31:'1439x-788y1610z',
                32:'1493x-718y1594z',
                33:'1505x-1165y1290z',
                34:'1530x-1699y246z',
                35:'1543x-645y1577z',
                36:'155x-441y2251z',
                37:'1574x-1092y1271z',
                38:'1590x-569y1560z',
                39:'160x-110y2291z',
                40:'1618x-1618y223z',
                41:'1632x-490y1543z',
                42:'1640x-1015y1252z',
                43:'1671x-407y1526z',
                44:'1702x-1533y200z',
                45:'1702x-933y1233z',
                46:'1705x-322y1509z',
                47:'1734x-234y1492z',
                48:'1759x-144y1474z',
                49:'1759x-848y1213z',
                50:'1778x-52y1456z',
                51:'1782x-1443y177z',
                52:'1812x-760y1194z',
                53:'1856x-1348y154z',
                54:'185x-113y2289z',
                55:'187x-453y2247z',
                56:'1925x-1250y131z',
                57:'1942x-697y1225z',
                58:'1989x-1148y108z',
                59:'2047x-1043y85z',
                60:'2100x-935y62z',
                61:'211x-114y2287z',
                62:'2146x-824y39z',
                63:'2187x-710y16z',
                64:'220x-462y2242z',
                65:'234x-2228y518z',
                66:'238x-113y2284z',
                67:'255x-470y2236z',
                68:'264x-109y2282z',
                69:'291x-102y2279z',
                70:'291x-475y2231z',
                71:'318x-93y2275z',
                72:'328x-477y2225z',
                73:'345x-82y2272z',
                74:'351x-2218y495z',
                75:'366x-477y2219z',
                76:'371x-68y2268z',
                77:'376x-915y2076z',
                78:'396x-51y2264z',
                79:'405x-474y2213z',
                80:'421x-32y2260z',
                81:'432x-912y2066z',
                82:'444x-469y2207z',
                83:'445x-10y2256z',
                84:'467x-2201y473z',
                85:'484x-460y2200z',
                86:'489x-907y2055z',
                87:'524x-448y2193z',
                88:'547x-897y2045z',
                89:'564x-433y2186z',
                90:'583x-2178y450z',
                91:'604x-416y2179z',
                92:'605x-884y2034z',
                93:'613x-1299y1795z',
                94:'644x-395y2172z',
                95:'662x-868y2024z',
                96:'683x-371y2164z',
                97:'689x-1281y1781z',
                98:'698x-2149y428z',
                99:'720x-847y2013z',
                100:'721x-344y2156z',
                101:'758x-314y2148z',
                102:'764x-1258y1766z',
                103:'777x-823y2001z',
                104:'793x-281y2140z',
                105:'811x-2113y405z',
                106:'827x-245y2131z',
                107:'834x-795y1990z',
                108:'839x-1231y1751z',
                109:'849x-1580y1438z',
                110:'860x-206y2123z',
                111:'889x-763y1978z',
                112:'890x-165y2114z',
                113:'913x-1199y1736z',
                114:'919x-121y2104z',
                115:'922x-2071y382z',
                116:'938x-1546y1420z',
                117:'944x-727y1966z',
                118:'945x-74y2095z',
                119:'968x-25y2085z',
                120:'986x-1163y1721z',
                121:'997x-688y1954z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2300four4xi" usage = "target function for charge23004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2300four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2300FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2300FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2300FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2300FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2300FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four23004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2300FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2300FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2300FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four23004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four23004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2300FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2300FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2300FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2300four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                    